byte text_max = 5;
String text[5] = {"My name's CHDWin", "I love you", "Security", "I have computer", "We family!"};









#include <LiquidCrystal.h>
#include <GyverEncoder.h>

LiquidCrystal lcd(12, 11, 5, 4, 3, 2);
Encoder enc(8, 9, 10);

byte punt = 1;
byte punt_min = 1;
byte punt_max = 3;
boolean flag = false;
byte sec = 0;
byte min = 0;
byte timer_punt = 1;
byte timer_tick_upd = 0;
byte text_id = 0;

void setup() {
  // put your setup code here, to run once:
  lcd.begin(16, 2);
  enc.setType(TYPE2);
  startMenu();
}

void loop() {
  // put your main code here, to run repeatedly:
  tick();
}

void startMenu() {
  lcd.clear();
  lcd.setCursor(5, 0);
  lcd.print("Hello!");
  lcd.setCursor(3, 1);
  lcd.print("CHDWindows");
  delay(2500);
}

void drawMenu() {
  static uint32_t upd_timer = 0;
  if (millis() - upd_timer >= 250) {
    upd_timer = millis();
    switch (punt) {
      case 1:
        lcd.clear();
        lcd.setCursor(5, 0);
        lcd.print("Timer");
        lcd.setCursor(0, 1);
        lcd.print("<-back");
        lcd.setCursor(10, 1);
        lcd.print("next->");
        break;
      case 2:
        lcd.clear();
        lcd.setCursor(3, 0);
        lcd.print("Stopwatch");
        lcd.setCursor(0, 1);
        lcd.print("<-back");
        lcd.setCursor(10, 1);
        lcd.print("next->");
        break;
      case 3:
        lcd.clear();
        lcd.setCursor(6, 0);
        lcd.print("Text");
        lcd.setCursor(0, 1);
        lcd.print("<-back");
        lcd.setCursor(10, 1);
        lcd.print("next->");
        break;
    }
  }
}

void encoder() {
  enc.tick();
  if (enc.isRight()) {
    if (!flag) {
      if (punt < punt_max) {
        punt++;
      }
    }
    if (flag) {
      if (punt == 1 and timer_punt == 1) {
        sec++;
        if (sec == 60) {
          min++;
          sec = 0;
        }
      }
      if (punt == 3){
        byte max = text_max;
        max--;
        if (text_id < max){
          text_id++;
        }
      }
    }
  }
  if (enc.isLeft()) {
    if (!flag) {
      if (punt > punt_min) {
        punt--;
      }
    }
    if (flag) {
      if (punt == 1 and timer_punt == 1) {
        if (sec == 0 and min != 0) {
          min--;
          sec = 59;
          return;
        }
        if (sec != 0) {
          sec--;
        }
      }
      if (punt == 3){
        if (text_id > 0){
          text_id--;
        }
      }
    }
  }
  if (enc.isRightH()) {
    if (flag) {
      if (punt == 1 and timer_punt == 1) {
        min++;
      }
    }
  }
  if (enc.isLeftH()) {
    if (flag) {
      if (punt == 1 and timer_punt == 1) {
        if (min != 0) {
          min--;
        }
      }
    }
  }
  if (enc.isClick()) {
    if (!flag) {
      flag = !flag;
      sec = 0;
      min = 0;
      timer_punt = 1;
      return;
    }
    if (flag) {
      if (punt == 1) {
        if (timer_punt == 1) {
          timer_punt++;
        }
      }
    }

  }
  if (enc.isHolded()) {
    if (flag) {
      flag = !flag;
    }
  }
}

void programm() {
  if (flag) {
    if (punt == 1) {
      static uint32_t timer_upd;
      if (millis() - timer_upd >= 100) {
        timer_upd = millis();
        timer();
      }
    }
    if (punt == 2) {
      static uint32_t secunds_upd;
      if (millis() - secunds_upd >= 100) {
        secunds_upd = millis();
        secunds_p();
      }
    }
    if (punt == 3){
      static uint32_t text_upd;
      if (millis() - text_upd >= 100){
        text_upd = millis();
        text_p();
      }
    }
  }
}

void timer() {
  if (timer_punt == 1) {
    static uint32_t upd_timer_1;
    if (millis() - upd_timer_1 >= 100) {
      upd_timer_1 = millis();
      lcd.clear();
      lcd.setCursor(4, 0);
      lcd.print("Timer on");
      lcd.setCursor(5, 1);
      if (min < 10) {
        lcd.print("0");
      }
      lcd.print(min);
      lcd.print(":");
      if (sec < 10) {
        lcd.print("0");
      }
      lcd.print(sec);
    }
  }
  if (timer_punt == 2) {
    if (timer_tick_upd != 9) {
      timer_tick_upd++;
    } else {
      timer_tick_upd = 0;
      if (sec == 0) {
        min--;
        sec = 59;
      } else {
        sec--;
      }
    }

    lcd.clear();
    lcd.setCursor(5, 0);
    lcd.print("Timer");
    lcd.setCursor(5, 1);
    if (min < 10) {
      lcd.print("0");
      lcd.print(min);
    } else {
      lcd.print(min);
    }
    lcd.print(':');
    if (sec < 10) {
      lcd.print("0");
      lcd.print(sec);
    } else {
      lcd.print(sec);
    }

    if (sec == 0 and min == 0) {
      timer_punt++;
    }
  }
  if (timer_punt == 3) {
    lcd.clear();
    lcd.setCursor(4, 0);
    lcd.print("Time out");
  }
}

void secunds_p() {
  static byte upd_sec;
  if (upd_sec != 10) {
    upd_sec++;
  } else {
    upd_sec = 0;
    sec++;
    if (sec == 60) {
      min++;
      sec = 0;
    }
    lcd.clear();
    lcd.setCursor(3, 0);
    lcd.print("Stopwatch");
    lcd.setCursor(5, 1);
    if (min < 10) {
      lcd.print("0");
      lcd.print(min);
    } else {
      lcd.print(min);
    }
    lcd.print(':');
    if (sec < 10) {
      lcd.print("0");
      lcd.print(sec);
    } else {
      lcd.print(sec);
    }
  }
}
void text_p(){
  lcd.clear();
  lcd.setCursor(6, 0);
  lcd.print("Text");
  lcd.setCursor(0, 1);
  lcd.print(text[text_id]);
}

void tick() {
  encoder();
  programm();
  static uint32_t upd_menu;
  if (millis() - upd_menu >= 200 and !flag) {
    drawMenu();
  }
}
